package org.gcube.informationsystem.utils.documentation.model.relations;

import org.gcube.informationsystem.base.reference.AccessType;
import org.gcube.informationsystem.base.reference.relations.RelationElement;
import org.gcube.informationsystem.types.TypeMapper;
import org.gcube.informationsystem.types.reference.Type;
import org.gcube.informationsystem.utils.documentation.model.DocumentationGenerator;
import org.gcube.informationsystem.utils.documentation.rst.table.Table;

/**
 * @author Luca Frosini (ISTI - CNR)
 */
public class RelationDocumentationGenerator extends DocumentationGenerator {

	public RelationDocumentationGenerator(Type type) {
		super(type, AccessType.RELATION, TypeMapper.getType(RelationElement.class));
	}
	
	protected RelationDocumentationGenerator(Type type, AccessType requiredType) {
		super(type, requiredType);
	}
	
	protected RelationDocumentationGenerator(Type type, AccessType requiredType, String superClassToBeExcluded) {
		super(type, requiredType, superClassToBeExcluded);
	}

	@Override
	protected Table getTable() {
		Table table = new Table();
		table.appendRow(getPropertyFieldsHeadingRow());
		
		return table;
	}

	
}
